#ifndef __ZH_TRICOLOR_SDK_H__
#define __ZH_TRICOLOR_SDK_H__

#ifdef TRICOLORSDK_EXPORTS
#define TRICOLORSDK_EXPORT_API __declspec(dllexport)
#else
#define TRICOLORSDK_EXPORT_API __declspec(dllimport)
#endif

#ifdef __cplusplus
extern "C" {
#endif

#define TRICOLORSDK_CALLTYPE __cdecl

//豸ĲĻص֪ͨ
//uDeviceID, 豸ID߼ϵIDʵ豸ûйϵ
//pNotifiedData, ֪ͨľݣûͬصĲͬ
//uCommandǰ
//pUserParamûݲע豸SDKа󶨵û
typedef void(TRICOLORSDK_CALLTYPE *OnDeviceNotify)(unsigned int uDeviceId, void* pNotifiedData, unsigned int uCommand, void* pUserParam);

namespace ZHSDK_TRICOLOR
{
	enum TEXT_ENCODE_MODE
	{
		TEXT_ENCODE_NONE=-1,
		TEXT_ENCODE_UNICODE=0,
		TEXT_ENCODE_GB2312=1
	};

	enum TEXT_COLOR_TYPE
	{
		TEXT_COLOR_NONE,
		TEXT_COLOR_RED=1,
		TEXT_COLOR_GREEN=2,
		TEXT_COLOR_YELLOW=3,
		TEXT_COLOR_BLUE=4,
		TEXT_COLOR_PURPLE=5,
		TEXT_COLOR_CYAN=6,
		TEXT_COLOR_WHITE=7,
		TEXT_COLOR_MAXVALUE
	};

	enum LIGHTNESS_VALUE
	{
		LIGHTNESS_NONE,
		LIGHTNESS_MINVALUE= 1,
		LIGHTNESS_MAXVALUE= 15
	};

	//ȡǰSDKİ汾
	//汾汾ʹΰ汾ԼС汾ĸֽ϶
	//	   MajorVersion.MinorVersion.SubVersion.ReservedVersion
	//MajorVersion24λ32λ
	//MinorVersion16λ24λ
	//SubVersion  8λ16λ
	unsigned int TRICOLORSDK_EXPORT_API TRICOLORSDK_CALLTYPE GetVersion();

	//ʼ
	//ʼǰ
	//sIp عõIPַʽΪxxx.xxx.xxx.xxx
	//	   uPort عģʽʱõPort
	//	   uHeartBeatTimeout عģʽʱ ms
	//	   sDeviceType عģʽʱ˵豸
	
	//[****رע****]
	//úз֮ǰ
	//ǰ汾InitвЧ
	//ǰ汾IPַͶ˿ڣϷУ飬ⲿ֤Ч
	
	int TRICOLORSDK_EXPORT_API TRICOLORSDK_CALLTYPE Init(const char* sIp = NULL,
									unsigned short uPort=60000, 
									unsigned int uHeartBeatTimeout=10000, 
									const char* sDeviceType="ZH_E8L");
	//豸豸б
	//һ̨豸Ϣ豸бڸ¸豸Ϣʵ豸, ٸ豸״̬
	//sIp 豸IPַ ʽΪxxx.xxx.xxx.xxx
	//	   uPort 豸Port
	//     OnDeviceNotify 豸״̬仯Ļص
	//	   pUserParam صʱûԶ
	//ֵ 豸߼IDţ0ΪʧܣΪɹ
	//ע⣺豸Ľ
	//     ǰ첽֪ͨʽͨص֪ͨ
	//[****رע****]
	//ǰ汾InitвЧ
	//ǰ汾IPַͶ˿ڣϷУ飬ⲿ֤Ч
	unsigned int TRICOLORSDK_EXPORT_API TRICOLORSDK_CALLTYPE RegisterDevice(const char* sIp,
												       unsigned int uPort, 
													   OnDeviceNotify fNotify=NULL, 
													   void* pUserParam=NULL);
	//ɾ豸бɾһ̨豸Ͽʵ豸
	//: uDevId 豸ID
	//ֵ1ɹ
	//       0: ʧ
	int TRICOLORSDK_EXPORT_API TRICOLORSDK_CALLTYPE UnregisterDevice(unsigned int uDevId);

	//һ̨豸
	//ʵʵɹ
	//: uDevId 豸ID
	//ֵ1ɹ
	//       0: ʧ
	int TRICOLORSDK_EXPORT_API TRICOLORSDK_CALLTYPE OpenDevice(unsigned int uDevId);

	//Ϩһ̨豸
	//ʵʵɹ豸ע᷽ʽȷ 
	//: uDevId 豸ID
	//ֵ1ɹ
	//       0: ʧ
	int TRICOLORSDK_EXPORT_API TRICOLORSDK_CALLTYPE CloseDevice(unsigned int uDevId);

	//Ϩһ̨豸
	//ʵʵɹ豸ע᷽ʽȷ 
	//: uDevId 豸ID
	//	    uLightnessValue ֵ, 
	//		ȡֵΧΪ[LIGHTNESS_MINVALUE, LIGHTNESS_MAXVALUE]ʵ豸
	//ֵ1ɹ
	//       0: ʧ
	int TRICOLORSDK_EXPORT_API TRICOLORSDK_CALLTYPE SetDeviceLightness(unsigned int uDevId,
												  unsigned int uLightnessValue);

	//ʾָ豸ļ
	//: uDevId 豸ID
	//	    uEncodeMode õı뷽ʽ
	//		ֱ֧뷽ʽ[TEXT_ENCODE_UNICODE, TEXT_ENCODE_GB2312],ҪӲ֧
	//	    uColor ıϢõɫ ȡֵΧΪ[TEXT_COLOR_TYPE], ʵ豸֧
	//		pText Ҫʾıݣunicodeʽ
	//      uField ַڷΧΪ[0, 65535]
	//ֵ1ɹ
	//       0: ʧ
	int TRICOLORSDK_EXPORT_API TRICOLORSDK_CALLTYPE ShowInstantText(unsigned int  uDevId,
												unsigned int  uEncodeMode,
												unsigned int  uColor, 
												const wchar_t * pText,
												unsigned int uField = 0);
	//ɾָ豸ļ
	//: uDevId 豸ID
	//ֵ1ɹ
	//       0: ʧ
	int TRICOLORSDK_EXPORT_API TRICOLORSDK_CALLTYPE HideInstantText(unsigned int  uDevId,
											   unsigned int uField = 0);

	//ָ豸ָ
	//: uDevId 豸ID
	//      uStringIndex ڴ洢豸߼к,ʵ豸ֵ֧Χ
	//	    uEncodeMode õı뷽ʽ
	//		ֱ֧뷽ʽ[TEXT_ENCODE_UNICODE, TEXT_ENCODE_GB2312],ҪӲ֧
	//	    uColor ıϢõɫ ȡֵΧΪ[TEXT_COLOR_TYPE], ʵ豸֧
	//		pText Ҫʾıݣunicodeʽ
	//ֵ1ɹ
	//       0: ʧ
	int TRICOLORSDK_EXPORT_API TRICOLORSDK_CALLTYPE UpdateDeviceText(unsigned int  uDevId,
												unsigned int  uStringIndex,
												unsigned int  uEncodeMode,
												unsigned int  uColor,
												const wchar_t* pText,
												unsigned int uField = 0);
	//лָ豸ֲָʾ
	//: uDevId 豸ID
	//      uStringIndex ڴ洢豸߼к,ʵ豸ֵ֧Χ
	//      uField ַڷΧΪ[0, 65535]
	//ֵ1ɹ
	//       0: ʧ
	int TRICOLORSDK_EXPORT_API TRICOLORSDK_CALLTYPE SwitchDeviceText(unsigned int uDevId,
												int StringIndex,
												unsigned int uField = 0);

	//ɾָ豸еָ
	//: uDevId 豸ID
	//      uStringIndex ڴ洢豸߼к,ʵ豸ֵ֧Χ
	//      uField ַڷΧΪ[0, 65535]
	//ֵ1ɹ
	//       0: ʧ
	int TRICOLORSDK_EXPORT_API TRICOLORSDK_CALLTYPE DeleteDeviceText(unsigned int uDevId,
												unsigned int uStringIndex,
												unsigned int uField = 0);
	//ʼ
	//ͷеǰʹõϵͳԴ
	//÷֮зĵöʧ[Init]
	//ֵ1ɹ
	//       0: ʧ
	int TRICOLORSDK_EXPORT_API TRICOLORSDK_CALLTYPE DeInit();
}

#ifdef __cplusplus
}
#endif

#endif